VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"371F533802E9"
'------------------------------------------------------------------------------
'
'  CLASS NAME: CCollection
'
'  DESCRIPTION
'  -----------
'  This class has been developed by Microsoft and corrects a bug in the
'  standard Microsoft Collection.
'  No comments are added since the code has been generated by Microsoft and
'  included in our code as delivered to us.
'------------------------------------------------------------------------------

Option Explicit

Private m_cList As VBA.Collection

Public Sub Add(ByVal Item As Variant, Optional Key As Variant, Optional ByVal Before As Variant, Optional ByVal After As Variant)
    m_cList.Add Item, Key, Before, After
End Sub

Public Sub Remove(Key As Variant)
    m_cList.Remove Key
End Sub

Public Property Get Count() As Long
    Count = m_cList.Count
End Property

Public Property Get Item(Key As Variant) As Variant
Attribute Item.VB_UserMemId = 0
    
    On Error Resume Next
    
    If m_cList.Count > 0 Then
        If IsObject(m_cList(Key)) Then
            Set Item = m_cList(Key)
        Else
            Item = m_cList(Key)
        End If
    End If
End Property

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
    On Error Resume Next
    Set NewEnum = m_cList.[_NewEnum]
End Property

Private Sub Class_Initialize()
    Set m_cList = New Collection
End Sub

Private Sub Class_Terminate()
    Set m_cList = Nothing
End Sub

'------------------------------------------------------------------------------
'  COLLECTION ENHANCEMENT METHODS
'------------------------------------------------------------------------------

'------------------------------------------------------------------------------
' Add a new item to my collection, returning a reference to the value.
' Do nothing if there is already a item with that key.
'------------------------------------------------------------------------------
    
Public Function AddIfAbsent(vValue As Variant, sKey As String) As Variant
    
    On Error GoTo ErrorHandler
        
    ' do the add second, since it might trigger an error
    Me.Add vValue, sKey
    
    ' return a reference to value at key
    If IsObject(vValue) Then
        Set AddIfAbsent = vValue
    Else
        AddIfAbsent = vValue
    End If
    
Exit Function
ErrorHandler:
        ' ignore key already present error, but raise all others
        ' return a reference to value at key
        If Err.Number = cmErrColKeyAlreadyPresent Then
            If IsObject(m_cList(sKey)) Then
                Set AddIfAbsent = m_cList(sKey)
            Else
                AddIfAbsent = m_cList(sKey)
            End If
        Else
            Err.Raise Err.Number
        End If
    End Function


'------------------------------------------------------------------------------
' TESTING FUNCTIONS
'------------------------------------------------------------------------------

'------------------------------------------------------------------------------
' Answer true if their is a pair in my collection with the specified key,
' otherwise false.
'------------------------------------------------------------------------------

Public Function IncludesKey(sKey As String) As Boolean
    On Error GoTo ErrorHandler
    
    ' assume the key is present
    IncludesKey = True
    
    ' try to retrieve the pair with the specified key
    ' this will trigger an error if the key is not present
    Dim vValue As Variant
    If IsObject(m_cList(sKey)) Then
        Set vValue = m_cList.Item(sKey)
    Else
        vValue = m_cList.Item(sKey)
    End If
    
Exit Function
ErrorHandler:
        
    ' ignore key not present errors but raise all others
    Select Case Err.Number
        Case cmCColKeyNotFound, cmErrColKeyNotPresent
            IncludesKey = False
        Case Else
            Err.Raise Err.Number
    End Select

End Function

